--with trace
-- CRUNCH.E
-- 29 line long Picture crunch/expanding routine
-- Works on anything!
-- Syntax: image = crunch(image, crunchFactor)
-- crunchFactor is a 2-element sequence. [1] is the crunch factor for the x
-- pixels(to make it 2x smaller, but let it be just as tall, set crunchFactor
-- to {2,1}). And of course, [2] is the crunch factor for the y pixels. To make
-- either the x or the y larger, specify a negative chrunch factor.

function Abs(atom number) -- In July 1999, someone posted this one-liner to
    return sqrt( number * number ) -- the Euphoria mailing list
end function
global function crunch(sequence img,sequence factor) -- Main cruncher
    sequence img2,tmp
    atom num1,num2,fact1,fact2
    num1=1
    num2=1
    img2 = {}
    fact1 = factor[1] fact2=factor[2]
    if fact1=0 then
	fact1=1
    end if
    if fact2=0 then
	fact2=1
    end if
    if fact1 <= 0 then -- Is factor below <= 0?
	num1 = Abs(fact1) -- Set blow-up factor
	fact1 = 1         -- Scan each pixel
    end if
    if fact2 <= 0 then    -- Ditto
	num2 = Abs(fact2) -- Ditt
	fact2 = 1         -- Dit
    end if                -- Di
    for z = 1 to length(img) by fact2 do -- Scan each fact2-th line
	tmp={}
	for y = 1 to length(img[z]) by fact1 do -- Scan each fact1-th pixel
	    tmp &= repeat(img[z][y],num2)       -- Repeat each pixel num2 times
	end for
	--img[z] = tmp -- Replace this line
	img2 &= repeat(tmp,num1) -- Repeat the line num1 times
    end for
    return img2
end function
function changesize(sequence img,sequence newXY) -- Main size-changer
    sequence xy
    xy={length(img[1]),length(img)}
    img=crunch(img,xy/newXY)
    return img
end function
-- Crunching twice avoids weird lines in between the lines
global function changeSize(sequence img,sequence newXY)
    img=changesize(img,{length(img[1]),newXY[2]})
    img=changesize(img,newXY)
    return img
end function
