-- An extremely primitive, basic, and prototypical core program. It's modeled
-- somewhat after CPUs: The program files contain individual bytes that go to
-- the CPU, and are interpreted as action. In this program, files containing
-- code are converted to a Euphoria sequence containing Topaz instructions.
-- Normal number values are just "there". However, strings are more complex.
-- Because strings must be written as individual bytes, they need some kind of
-- marker to tell the program that it's a string, and not a bunch of numbers.
-- In version 0 files, the format for a string is as follows:
-- 255 000 021 "The string comes here"
-- Or, in version 1 files:
-- 255 000 "The string comes here" 000 255 187 64
-- The 255 and 0 bytes indicate that a string follows. The next byte, 21, ind-
-- icates the number of bytes in the string. In version 1 files, the 000 255
-- 187 64 bytes indicate

-- To use:
-- 1) Make sure you have your Topaz file ready
-- 2) Declare an integer to hold the thread ID for the file
-- 3) Make a line saying:
--    thread_ID = readTIL("topazFileName")

-- Note: You can use the constants tUPUSH and tUPOP to access the universal
-- stack.
without warning
include topaz.e
include get.e
include file.e
include machine.e
--uniStack={}
function getSlice(sequence lst,integer start,integer End)
    if start < 1 then
	start=1
    end if
    if End > length(lst) then
	End=length(lst)
    end if
    if End < 1 then
	End = length(lst)
    end if
    if start > length(lst) then
	start=length(lst)
    end if
    return lst[start..End]
end function
function getI(sequence lst,integer indx)
    if indx <= 0 or indx > length(lst) then
	return -1
    end if
    return lst[indx]
end function
function get4(integer fn)
    return bytes_to_int(get_bytes(fn,4))
end function
function find2(object i,sequence s)
    for z = length(s) to 1 by -1 do
	if equal(s[z],i) then
	    return z
	end if
    end for
    return 0
end function
procedure back(integer fn,integer bytes)
    integer huh
    huh=where(fn)
    if seek(fn,huh-bytes) then end if
end procedure
function lof(integer fn)
    integer pos,eof
    pos=where(fn)
    if seek(fn,-1) then end if
    eof=where(fn)
    if seek(fn,pos) then end if
    return eof
end function
-- Reads a TIL module
function readModule(integer fn,integer bigFmt,integer ver,integer i,integer waybig)
    sequence st,newst,a,tmp,tmp2
    integer len,instr,z,j,isstr,negative
    isstr=0
    i += 1
    a={}
    while 1 do
	i -= 1
	if i=0 then
	    exit
	end if
	len=getc(fn)
	if len=-1 then
	    exit
	elsif len=1 then
	    if getc(fn)=2 then
		if getc(fn)=3 then
		    exit
		else
		    back(fn,2)
		end if
	    else
		back(fn,1)
	    end if
	end if
	if bigFmt then
	    instr=get4(fn)
	    st = get_bytes(fn,len)
	    st = instr&st
	else
	    st = get_bytes(fn,len)
	end if
	z=0
	trace(1)
	while 1 do
	    z += 1
	    if z > length(st) then
		exit
	    end if
	    if st[z]=255 then
		if getI(st,z+1) = 0 then
		    isstr=1
		    newst=st[1..z-1]
		    if ver=0 then
--                      newst &= {st[z+3..z+3+(st[z+2]-1)]}
			newst &= {getSlice(st,z+3,z+3+getI(st,z+2)-1)}
		    elsif ver=1 then
--                      newst &= {st[z+2..match({0,255,128,64},st)-1]}
			tmp = getSlice(st,z+2,match({0,255,128,64},st)-1)
			if waybig then
			    tmp2=""
			    j=0
			    while 1 do
				j += 1
				if j > length(tmp) then
				    exit
				end if
				if tmp[j]=0 then
				    j += 1
				    tmp2 &= tmp[j]
				elsif and_bits(tmp[j],2)=2 then
				    j += 1
				    tmp2 &= float32_to_atom(tmp[j..j+3])
				    j += 4
				elsif and_bits(tmp[j],4)=4 then
				    j += 1
				    tmp2 &= tmp[j]*#100+tmp[j+1]
				    j += 2
				elsif and_bits(tmp[j],8)=8 then
				    j += 1
				    tmp2 &= bytes_to_int(tmp[j..j+3])
				    j += 4
				end if
				if and_bits(tmp[j],1)=1 then
				    tmp2[length(tmp2)]=-tmp2[length(tmp2)]
				end if
			    end while
			else
			    tmp2=tmp
			end if
			newst &= {tmp2}
		    end if
		    --newst &= {getSlice(st,z+3,z+3+(getI(st,z+2-1)))}
		    -- Is there more after the processed string?
		    if z+4+(getI(st,z+2)) != length(st) then
			-- Yes. Stick it at the end, and if any of the data is a
			-- string, to process it.
			if ver=0 then
			    newst &= st[z+3+(st[z+2])..length(st)]
--                          newst &= getSlice(st,z+3+(getI(st,z+2)),length(st))
			elsif ver=1 then
			    newst &= st[match({0,255,128,64},st)+4..length(st)]
--                          newst &= getSlice(st,match({0,255,128,64},st)+4,length(st))
			end if
		    end if
		    st=newst
		else
		end if
	    end if
	    tmp={}
	    if waybig=0 then
		newst=st
	    else
		if isstr=0 then
		    tmp2=""
		    if bigFmt then
			j=3
		    else
			j=0
		    end if
		    newst={}
		    if z+1 <= length(st) then
			z += 1
			tmp={st[z],st[z+1]}
		    else
			j=length(st)
			tmp2={st[z]}
			tmp={}
		    end if
		    while 1 do
			j += 1
			if j > length(tmp) then
			    exit
			end if
			negative=and_bits(tmp[j],1)=1
			if tmp[j]=0 then
			    j += 1
			    z += 1
			    tmp2 &= tmp[j]
			elsif and_bits(tmp[j],2)=2 then
			    j += 1
			    z += 1
			    tmp2 &= float32_to_atom(tmp[j..j+3])
			    j += 4
			    z += 4
			elsif and_bits(tmp[j],4)=4 then
			    j += 1
			    z += 1
			    tmp2 &= tmp[j]*#100+tmp[j+1]
			    j += 2
			    z += 2
			elsif and_bits(tmp[j],8)=8 then
			    j += 1
			    z += 1
			    tmp2 &= bytes_to_int(tmp[j..j+3])
			    j += 4
			    z += 4
			end if
			if negative then
			    tmp2[length(tmp2)]=-tmp2[length(tmp2)]
			end if
		    end while
		    newst &= tmp2
		end if
	    end if
	end while
	if length(tmp) then
	    newst = st[1] & newst
	end if
	st=newst
	--st[1] -= 1
	a &= {st}
    end while
    return a
end function
global function readTIL(sequence fN)
    sequence a,bytes,st,newst,cms,mainCms,waybig
    object dataSize,prior,id,tflags
    integer len,z,fn,nomore,i,j,ver,instr,bigFmt,modules,mlen
    cms=""
    nomore=0
    a={}
    fn=open(fN,"rb")
    if fn=-1 then
	return -1
    end if
    if not equal(get_bytes(fn,5),"TOPAZ") then
	return -2
    end if
    ver=getc(fn)
    len=getc(fn)
    if ver=0 then
	cms=get_bytes(fn,len)
    else
	mainCms=get_bytes(fn,len)
	len=getc(fn)
	for k = 1 to len do
	    mlen=getc(fn)
	    cms &= {get_bytes(fn,mlen)}
	end for
    end if
    if ver=1 then
	modules=getc(fn)
	dataSize={} prior={}
	for k = 1 to modules do
	    dataSize &= get4(fn)
	end for
	tflags=get_bytes(fn,modules)
	for k = 1 to modules do
	    prior &= getc(fn)
	end for
	waybig=get_bytes(fn,modules)
    else
	dataSize=get4(fn)
	tflags=getc(fn)
	prior=getc(fn)
    end if
    bigFmt=getc(fn) -- 4-byte codes instead of 1-byte
    if ver=0 then
	a=readModule(fn,bigFmt,ver,-1,0)
	close(fn)
	id=new_thread(dataSize,prior,a)
	setThreadName(id,cms)
	setFlags(id,tflags)
	return {id,cms}
    else
	id={}
	for b = 1 to modules do
	    mlen=get4(fn)
	    a = readModule(fn,bigFmt,ver,mlen,waybig[b])
	    id &= new_thread(dataSize[b],prior[b],a)
	    setThreadName(id[b],sprintf("%s",{cms[b]}))
	    setFlags(id[b],tflags[b])
	end for
	return {id,mainCms}
    end if
end function
