-- Two threads are delayed individually. To end the demo, press Escape.
-- This program creates a multithread TIL file called TIMER.TPZ
include mkti2.e
include topaz2.e
sequence code1,code2,code3,allFlags
integer id1,id2,id3
code1={
       {tADDPROG,"clock.tpz"},
       {tPUSHD,2,1},
       {tDIV},
       {tDELAY},
       {tPUTST,"This is thread 1\n"},
       {tJMP,2}
      }
id1=new_thread(0,0,code1)
code2={
       {tDELAY,1},
       {tPUTST,"This is thread 2\n"},
       {tJMP,1}
      }
id2=new_thread(0,0,code2)
code3={
       {tGETKY},
       {tPUSHD,27},
       {tNEQ},
       {tIF,{tJMP,1}},
       {tFINDNAME,"Timer 1"},
       {tKILL},
       {tFINDNAME,"Timer 2"},
       {tKILL},
       {tPUTST,"Goodbye\n"},
       {tEND}
      }
id3=new_thread(0,0,code3)
setThreadName(id1,"Timer 1")
setThreadName(id2,"Timer 2")
setThreadName(id3,"Shutdown")
setFlags(id3,FLAGS_KILL2+FLAGS_READONLY+FLAGS_DONTKEEP)
while get_num_threads() do
    topaz_step()
end while
allFlags={getFlags(id1),getFlags(id2),getFlags(id3)}
makeTIL({code1,code2,code3},{0,0,0},allFlags,"timer.tpz",{"Multimodule TIL example","Timer 1","Timer 2","Shutdown"},{0,0,0},0)
