-- Topaz2.e
--
-- Extensions to the instruction set for the Topaz Scripting Engine(v1.0)
-- Adds 116 constants(uses five internally. You wouldn't make much use of them
-- in your own prog anyway)
without warning
include wildcard.e
include machine.e
include graphics.e
include get.e
include misc.e
include runscr.e
include topaz.e
include image.e
include rat.e
include crunch.e
include ports.e
constant actions = {
		    "Suspend,",
		    "Resume,",
		    "Never mind"
		   }
global sequence cmd_line
global integer error_checker
sequence errcode
integer running,SuspendedID,keyID,priority
atom t,t1
tick_rate(200)
timers={}
sIDs2={}
tmrIDs={}
fpos={}
opened={}
sIDs={}
keyIDs={}
cmd_line={}
ipStack={}
running=0
msgs={}
vars={}
vlist={}
files={}
modes={}
global sequence uniStack
opened={}
procedure dec_ip(integer ip)
    inc_ip(-ip)
end procedure
type number(object x)
    return not sequence(x)
end type
function correct(integer x)
    if x>=0 and x<=1 then
	return 1
    elsif x>=2 and x<=3 then
	return 2
    elsif x>=4 and x<=6 then
	return 3
    end if
    return x
end function
function bitsin(number x)
    return correct(length(sprintf("%x",x))*4)
end function
function removeIndex(sequence list,integer item)
    if item=1 then -- Avoid errors!
	return list[2..length(list)]
    elsif item=length(list) then
	return list[1..length(list)-1]
    end if
    return list[1..item-1]&list[item+1..length(list)]
end function
global procedure topaz_color (sequence params)
    integer fg,bg
    fg=params[1]
    bg=params[2]
    if fg > -1 then
	text_color(fg)
    end if
    if bg > -1 then
	bk_color(bg)
    end if
end procedure
global procedure topaz_color2 (sequence params)
    integer fg,bg
    fg=pop_stack()
    if fg=#FFFF then return end if
    bg=pop_stack()
    if bg=#FFFF then return end if
    if fg > -1 then
	text_color(fg)
    end if
    if bg > -1 then
	bk_color(bg)
    end if
end procedure
global procedure topaz_putst(sequence params)
    integer device
    object str
    if length(params)=0 then
	device=pop_stack()
	if device=#FFFF then return end if
	str=pop_stack()
    else
	str=params[1]
	device=1
    end if
    --str=params[1]
    puts(device,str)
    --push_stack(device)
end procedure
global procedure floppies(sequence params)
    integer fcount
    fcount=floor(peek(#410)/64+1)
    push_stack(fcount)
end procedure
global procedure topaz_open(sequence params)
    integer fn
    sequence fil
    object mode
    if length(params) >= 2 then
	fil=params[1]
	mode=params[2]
    else
	mode=pop_stack()
	if equal(mode,#FFFF) then return end if
	fil=pop_stack()
    end if
    if atom(mode) then
	mode={mode}
    end if
    fn=open(fil,mode)
    fpos &= 0
    opened &= fn
    modes &= {mode}
    files &= {fil}
    push_stack(fn)
end procedure
global procedure topaz_close(sequence params)
    integer fn
    object param
    if length(params) then
	param=params[1]
	if integer(param) then
	    fn=param
	else
	    return
	end if
    else
	param=pop_stack()
	if param=#FFFF then return end if
	if integer(param) then
	    fn=param
	else
	    return
	end if
    end if
    if not find(fn,opened) then
	return
    end if
    close(fn)
    opened=removeIndex(opened,find(fn,opened))
end procedure
procedure topaz_print(sequence params)
    integer device
    object data
    device=pop_stack()
    if device=#FFFF then return end if
    data=pop_stack()
    print(device,data)
    push_stack(device)
end procedure
procedure topaz_dosver(sequence params)
    sequence regs
    integer major,minor
    if platform()=WIN32 then
	push_stack(0)
	push_stack(0)
	return
    end if
    regs=repeat(0,10)
    regs[REG_AX]=#3000
    regs=dos_interrupt(#21,regs)
    if and_bits(regs[REG_FLAGS],1) then
	push_stack(-1)
	push_stack(-1)
	return
    end if
    major=remainder(regs[REG_AX],#100)
    minor=floor(regs[REG_AX]/#100)
    push_stack(minor)
    push_stack(major)
end procedure
procedure topaz_lshift(sequence params)
    sequence bits
    integer num,bitsto
    bitsto=pop_stack()
    if bitsto=#FFFF then return end if
    num=pop_stack()
    if num=#FFFF then return end if
    bits=int_to_bits(num,bitsin(num))
    bits &= 0
    num=bits_to_int(bits)
    push_stack(num)
end procedure
procedure topaz_rshift(sequence params)
    sequence bits
    integer num,bitsto
    bitsto=pop_stack()
    if bitsto=#FFFF then return end if
    num=pop_stack()
    if num=#FFFF then return end if
    bits=int_to_bits(num,bitsin(num))
    bits=bits[1..length(bits)-1]
    num=bits_to_int(bits)
    push_stack(num)
end procedure
procedure topaz_rol(sequence params)
    sequence b1,b2
    integer num,bitsto
    num=pop_stack()
    if num=#FFFF then return end if
    bitsto=pop_stack()
    if bitsto=#FFFF then return end if
    b1=int_to_bits(num,bitsin(num))
    b2=b1[1..bitsto]
    b1=b1[bitsto+1..length(b1)]&b2
    push_stack(bits_to_int(b1))
end procedure
procedure topaz_ror(sequence params)
    sequence b1,b2
    integer num,bitsto
    num=pop_stack()
    if num=#FFFF then return end if
    bitsto=pop_stack()
    if bitsto=#FFFF then return end if
    b1=int_to_bits(num,bitsin(num))
    b2=b1[length(b1)-(bitsto-1)..length(b1)]
    b1=b1[1..length(b1)-bitsto]&b2
    push_stack(bits_to_int(b1))
end procedure
procedure uniPush(sequence params)
    for z = 1 to length(params) do
	uniStack = append(uniStack,params[z])
    end for
end procedure
procedure uniPop(integer items)
    sequence popped
    if length(uniStack)=0 then
	push_stack({})
	return
    elsif items > length(uniStack) then
	push_stack(uniStack)
	return
    end if
    popped={}
    for z = length(uniStack) to length(uniStack)-items by -1 do
	popped &= uniStack[z]
    end for
    push_stack(popped)
end procedure
procedure printh(sequence params)
    atom hdl,dat
    dat=pop_stack()
    if dat=#FFFF then return end if
    hdl=pop_stack()
    if hdl=#FFFF then return end if
    printf(hdl,"%x",dat)
end procedure
procedure printo(sequence params)
    atom hdl,dat
    dat=pop_stack()
    if dat=#FFFF then return end if
    hdl=pop_stack()
    if hdl=#FFFF then return end if
    printf(hdl,"%o",dat)
end procedure
procedure snd(sequence params)
    integer frq
    if length(params)=0 then frq=pop_stack() else
			    frq=params[1]    end if
    if frq=#FFFF then return end if
    sound(frq)
end procedure
procedure endtimer(sequence params)
    integer i,t
    t=get_thread_id()
    i=find(t,tmrIDs)
    if i then
	timers = removeIndex(timers,i)
	tmrIDs = removeIndex(tmrIDs,i)
	if thread_exists(sIDs2[i]) then resume(sIDs2[i]) end if
	sIDs2  = removeIndex(sIDs2,i)
    end if
end procedure
procedure gett(sequence params)
    push_stack(time())
end procedure
procedure gettmr(sequence params)
    integer i
    i=find(get_thread_id(),tmrIDs)
    if i then
	push_stack(timers[i])
    end if
end procedure
procedure getparent(sequence params)
    integer id,id2,i
    id2=get_thread_id()
    i=find(id2,tmrIDs)
    if i then
	id=sIDs2[i]
	if not thread_exists(id) then
	    endtimer({})
	end if
    end if
end procedure
constant GETT = add_instruction(routine_id("gett")),
	 GETTMR=add_instruction(routine_id("gettmr")),
	 tENDTIMER=add_instruction(routine_id("endtimer")),
	 tPARENT=add_instruction(routine_id("getparent"))
procedure Dly(sequence params)
    sequence timercode
    integer id
    atom sec,t0
    t1=0
    t=0
    if length(params)=0 then sec = pop_stack()
		       else sec = params[1]
		       end if
    if sec=#FFFF then return end if
    id=get_thread_id()
    sIDs2 &= id
    suspend(id)
    timers &= time()
    timercode = {
     {tPARENT},
     {GETTMR},
     {GETT},
     {tSUB},
     {tPUSHD,sec},
     {tGRTR},
     {tIF,{tINCIP,-5}},
     {tENDTIMER},
     {tEND}
    }
    t=time()
    tmrIDs &= new_thread(0,1,timercode)
    setThreadName(tmrIDs[length(tmrIDs)],"tmr")
end procedure
procedure dly(sequence params)
    atom t,sec
    t=time()
    if length(params) then
	sec=params[1]
    else
	sec=pop_stack()
    end if
    while time()<t+sec do
    end while
end procedure
procedure exec(sequence params)
    sequence prog
    integer mode
    if length(params)=0 then
	mode=pop_stack()
	prog=pop_stack()
    elsif length(params)=1 then
	mode=pop_stack()
	prog=params[1]
    else
	prog=params[1]
	mode=params[2]
    end if
    if mode=#FFFF then return end if
    system(prog,mode)
end procedure
procedure abrt(sequence params)
    if length(params)=0 then
	abort(pop_stack())
    else
	abort(params[1])
    end if
end procedure
procedure decIP(sequence params)
    if length(params)=0 then
	inc_ip(-pop_stack())
    else
	inc_ip(-params[1])
    end if
end procedure
procedure newVar(sequence params)
    object vr
    if length(params) then
	vr = params[1]
    else
	vr = pop_stack()
    end if
    if atom(vr) then
	return
    end if
    if not find(vr,vlist) then
	vars &= 0
	vlist &= {vr}
    end if
end procedure
procedure getVar(sequence params)
    object vr
    if length(params) then
	vr=params[1]
    else
	vr=pop_stack()
    end if
    if equal(vr,#FFFF) then return end if
    if not find(vr,vlist) then
	push_stack(0) return
    end if
    push_stack(vars[find(vr,vlist)])
end procedure
procedure setVar(sequence params)
    object vl,vr
    if length(params) >= 2 then
	vr=params[1]
	vl=params[2]
    else
	vl=pop_stack()
	if vl=#FFFF then return end if
	vr=pop_stack()
	if vr=#FFFF then return end if
    end if
    if not find(vr,vlist) then
	newVar({vr})
    end if
    vars[find(vr,vlist)]=vl
end procedure
procedure fsetVar(sequence params)
    sequence vr,fn
    if length(params)>=2 then
	vr=params[1]
	fn=params[2]
    else
	fn=pop_stack()
	if fn=#FFFF then return end if
	vr=pop_stack()
	if vr=#FFFF then return end if
    end if
    push_stack (params[2])
    inc_ip(-1)
    vars[find(vr,vlist)]=pop_stack()
end procedure
procedure var2Stack(sequence params)
    object vr
    if length(params) then
	vr=params[1]
    else
	vr=pop_stack()
    end if
    if vr=#FFFF then return end if
    push_stack(vars[find(vr,vlist)])
end procedure
procedure var2Vaddr(sequence params)
    integer va
    object vr
    if length(params)=2 then
	vr=params[1]
	va=params[2]
    else
	va=pop_stack()
	if va=#FFFF then return end if
	vr=pop_stack()
	if vr=#FFFF then return end if
    end if
    put_vaddress(vars[find(vr,vlist)],va)
end procedure
procedure cmdline(sequence params)
    sequence cmd
    cmd=cmd_line--command_line()
--  push_stack(cmd[3..length(cmd)])
    push_stack(cmd)
end procedure
procedure killthread(sequence params)
    integer id
    if length(params) then
	id=params[1]
    else
	id=pop_stack()
    end if
    if thread_exists(id) then
	kill_thread(id)
    end if
end procedure
procedure die(sequence params)
    kill_thread(get_thread_id())
end procedure
procedure graphMode(sequence params)
    integer mode
    if platform()=WIN32 then
	push_stack(1)
	return
    end if
    if length(params) then
	mode=params[1]
    else
	mode=pop_stack()
    end if
    if mode=12 then
	mode=-1
    end if
    push_stack(graphics_mode(mode))
end procedure
procedure polYgon(sequence params)
    integer color,fill,a
    sequence points
    if platform()=WIN32 then
	return
    end if
    points={}
    while 1 do
	a=pop_stack()
	if a=-1 then
	    exit
	end if
	points &= {a}
    end while
    fill=pop_stack()
    color=pop_stack()
    polygon(color,fill,points)
end procedure
procedure line(sequence params)
    sequence points
    integer color,a
    if platform()=WIN32 then
	return
    end if
    points={}
    while 1 do
	a=pop_stack()
	if a=-1 then
	    exit
	end if
	points &= {a}
    end while
    color=pop_stack()
    draw_line(color,points)
end procedure
procedure pixl(sequence params)
    sequence xy
    object color
    if platform()=WIN32 then
	return
    end if
    if length(params) then
	color=params[1]
	xy=params[2]
    else
	xy=pop_stack()
	color=pop_stack()
    end if
    pixel(color,xy)
end procedure
procedure getpixl(sequence params)
    sequence xy
    if length(params) then
	xy=params[1]
    else
	xy=pop_stack()
    end if
    push_stack(get_pixel(xy))
end procedure
procedure ellips(sequence params)
    sequence xy1,xy2
    integer color,fill
    if platform()=WIN32 then
	return
    end if
    if length(params) then
	color=params[1]
	fill=params[2]
	xy1=params[3]
	xy2=params[4]
    else
	xy2=pop_stack()
	xy1=pop_stack()
	fill=pop_stack()
	color=pop_stack()
    end if
    ellipse(color,fill,xy1,xy2)
end procedure
procedure put32(sequence params)
    integer fn
    atom fp
    if length(params) >= 1 then
	fn=params[1]
	if length(params) >= 2 then
	    fp=params[2]
	end if
    else
	fp=pop_stack() fn=pop_stack()
    end if
    puts(fn,atom_to_float32(fp))
end procedure
procedure put64(sequence params)
    integer fn
    atom fp
    if length(params) >= 1 then
	fn=params[1]
	if length(params) >= 2 then
	    fp=params[2]
	end if
    else
	fp=pop_stack() fn=pop_stack()
    end if
    puts(fn,atom_to_float64(fp))
end procedure
procedure get4(sequence params)
    integer fn
    if length(params) then
	fn=params[1]
    else
	fn=pop_stack()
    end if
    push_stack(get_bytes(fn,4))
end procedure
procedure revers(sequence params)
    if length(params) then
	push_stack(reverse(params[1]))
    else
	push_stack(reverse(pop_stack()))
    end if
end procedure
procedure Printf(sequence params)
    sequence data,st
    integer dev,items
    data={}
    items=pop_stack()
    st=pop_stack()
    for z = 1 to items do
	data &= {pop_stack()}
    end for
    data=reverse(data)
    dev=pop_stack()
    printf(dev,st,data)
end procedure
procedure year(sequence params)
    sequence dt
    dt=date()
    dt[1] += 1900
    push_stack(dt[1])
end procedure
procedure month(sequence params)
    sequence dt
    dt=date()
    push_stack(dt[2])
end procedure
procedure day(sequence params)
    sequence dt
    dt=date()
    push_stack(dt[3])
end procedure
procedure hour(sequence params)
    sequence dt
    dt=date()
    push_stack(dt[4])
end procedure
procedure minute(sequence params)
    sequence dt
    dt=date()
    push_stack(dt[5])
end procedure
procedure second(sequence params)
    sequence dt
    dt=date()
    push_stack(dt[6])
end procedure
procedure dow(sequence params)
    sequence dt
    dt=date()
    push_stack(dt[7])
end procedure
procedure doy(sequence params)
    sequence dt
    dt=date()
    push_stack(dt[8])
end procedure
procedure iscolor(sequence params)
    sequence vc
    vc=video_config()
    push_stack(vc[1])
end procedure
procedure mode(sequence params)
    sequence vc
    vc=video_config()
    push_stack(vc[2])
end procedure
procedure dimensions(sequence params)
    sequence vc
    vc=video_config()
    if vc[5] then
	push_stack(vc[6])
	push_stack(vc[5])
    else
	push_stack(vc[4])
	push_stack(vc[3])
    end if
end procedure
procedure colors(sequence params)
    sequence vc
    vc=video_config()
    push_stack(vc[7])
end procedure
procedure pages(sequence params)
    sequence vc
    vc=video_config()
    push_stack(vc[8])
end procedure
procedure textrows(sequence params)
    integer rows
    if length(params) then
	rows=params[1]
    else
	rows=pop_stack()
    end if
    push_stack(text_rows(rows))
end procedure
procedure pos(sequence params)
    sequence ps,vc
    integer row,col,gfxMode
    vc=video_config()
    gfxMode=vc[VC_MODE]
    ps=get_position()
    if length(params) >= 2 then
	row=params[1]
	col=params[2]
    else
	col=pop_stack()
	row=pop_stack()
    end if
    if row=-1 or row=51 then
	row=ps[1]
    end if
    if col=-1 or row=81 then
	col=ps[2]
    end if
    position(row,col)
    positions[ThreadPointer]={row,col,gfxMode}
end procedure
procedure getln(sequence params)
    integer fn,i
    object st
    if length(params) then
	fn=params[1]
    else
	fn=pop_stack()
    end if
    st=gets(fn)
    i=find(fn,opened)
    if i then
	fpos[i]=where(fn)
    end if
    push_stack(st)
end procedure
procedure getch(sequence params)
    integer fn,ch,i
    if length(params) then
	fn=params[1]
    else
	fn=pop_stack()
    end if
    ch=getc(fn)
    i=find(fn,opened)
    if i then
	fpos[i]=where(fn)
    end if
    push_stack(ch)
end procedure
procedure chop(sequence params)
    sequence st
    if length(params) then
	st=params[1]
    else
	st=pop_stack()
    end if
    push_stack(st[1..length(st)-1])
end procedure
procedure Getk(sequence p)
    push_stack(get_key())
end procedure
procedure cls(sequence p)
    sequence vc
    clear_screen()
    vc=video_config()
    positions[ThreadPointer]={1,1,vc[VC_MODE]}
end procedure
procedure addProg(sequence params) -- Add a new thread containing the Topaz
				  -- code in params[1], data space sized at
				  -- params[2] bytes
    sequence file
    object ret
    if length(params) then
	file=params[1]
    else
	file=pop_stack()
    end if
    ret=readTIL(file)
    if sequence(ret) then
	push_stack(ret[2]) --uniStack &= readTIL(params[1])
	push_stack(ret[1]) --uniStack &= readTIL(params[1])
    else
	push_stack(-1)
	push_stack(-1)
    end if
end procedure
procedure jump(sequence params)
    integer ip,IP
    ip=get_ip()
    if length(params) then
	IP=params[1]
    else
	IP=pop_stack()
    end if
    if ip > IP then
	dec_ip(ip-IP)
    elsif ip < IP then
	inc_ip(IP-ip)
    end if
end procedure
global procedure postmsg(integer msg,integer vl)
    if msg > 0 and msg <= length(msgs) then
	msgs[msg][3]=vl
    end if
end procedure
global procedure clearmsg(integer msg)
    if msg > 0 and msg <= length(msgs) then
	msgs[msg][3]=0
    end if
end procedure
global function getmsg(integer msg)
    integer i
    i=-1
    for a = 1 to length(msgs) do
	if msgs[a][1]=msg then
	    i=a
	    exit
	end if
    end for
    if i != -1 then
	return msgs[i][3]
    else
	return -1
    end if
end function
procedure post(sequence params)
    integer msg,vl
    if length(params) >= 2 then
	msg=params[1]
	vl=params[2]
    else
	vl=pop_stack()
	msg=pop_stack()
    end if
    postmsg(msg,vl)
end procedure
procedure getMsg(sequence params)
    integer msg
    if length(params) then
	msg=params[1]
    else
	msg=pop_stack()
    end if
    push_stack(getmsg(msg))
end procedure
procedure clearMsg(sequence params)
    integer msg
    if length(params) then
	msg=params[1]
    else
	msg=pop_stack()
    end if
    clearmsg(msg)
end procedure
procedure Loop(sequence params)
    integer ptr,cnt
    ptr=params[1]
    cnt=pop_stack()-1
    if cnt>0 then
	push_stack(cnt)
	jump({ptr})
    end if
end procedure
procedure threads(sequence params)
    push_stack(get_num_threads())
end procedure
function abs(atom num)
    return sqrt(num*num)
end function
global procedure setAutoResponse(sequence params)
    integer msg
    atom msgVal
    if length(params) >= 2 then
	msg=params[1]
	msgVal=params[2]
    else
	msgVal=pop_stack()
	msg=pop_stack()
    end if
    msgs[msg][3]=msgVal
end procedure
procedure popIP(sequence params)
    sequence IPs
    integer id,i,ip
    id=get_thread_id()+1
    IPs={}
    for z = 1 to length(ipStack) do
	IPs &= ipStack[z][1]
    end for
    if find(id,IPs) then
	i=find(id,IPs)
	ip=ipStack[i][2][length(ipStack[i][2])]
	ipStack[i][2]=ipStack[i][2][1..length(ipStack[i])-1]
	if length(ipStack[i][2])=0 then
	    ipStack=removeIndex(ipStack,i)
	end if
	jump({ip})
    end if
end procedure
global procedure callProc(sequence params)
    sequence IPs
    integer id,ip
    id=get_thread_id()+1
    if length(params) then
	ip=params[1]
    else
	ip=pop_stack()
    end if
    IPs={}
    for z = 1 to length(ipStack) do
	IPs &= ipStack[z][1]
    end for
    if find(id,IPs) then
	id=find(id,IPs)
	ipStack[id][2] &= get_ip()+1
    else
	ipStack = append(ipStack,{id,{get_ip()+1}})
    end if
    jump({ip})
end procedure
procedure tPeek(sequence params)
    integer len
    atom ptr
    if length(params) >= 1 then
	ptr=params[1]
	if length(params) >= 2 then len=params[2] end if
    else
	len=pop_stack()
	ptr=pop_stack()
    end if
    push_stack(peek({ptr,len}))
end procedure
procedure tPoke(sequence params)
    object dat
    atom ptr
    if length(params) then
	ptr=params[1]
	dat=params[2]
    else
	dat=pop_stack()
	ptr=pop_stack()
    end if
    poke(ptr,dat)
end procedure
procedure tPeek4u(sequence params)
    atom dat
    if length(params) then
	dat=peek4u(params[1])
    else
	dat=peek4u(pop_stack())
    end if
    push_stack(dat)
end procedure
procedure tPeek4s(sequence params)
    atom dat
    if length(params) then
	dat=peek4s(params[1])
    else
	dat=peek4s(pop_stack())
    end if
    push_stack(dat)
end procedure
procedure get32(sequence params)
    integer fn
    if length(params) then
	fn=params[1]
    else
	fn=pop_stack()
    end if
    push_stack(float32_to_atom(get_bytes(fn,4)))
end procedure
procedure get64(sequence params)
    integer fn
    if length(params) then
	fn=params[1]
    else
	fn=pop_stack()
    end if
    push_stack(float64_to_atom(get_bytes(fn,4)))
end procedure
procedure mouseCoords(sequence params)
    sequence vc
    integer x,y,mode
    x=rat_x
    y=rat_y
    vc=video_config()
    mode=vc[VC_MODE]
    --if mode <= 3 or mode=7 then
	--x = floor(x/8)+1
	--y = floor(y/8)+1
    if mode=19 or mode=13 then
	x = floor(x/2)
    end if
    push_stack(y)
    push_stack(x)
end procedure
procedure setCoords(sequence params)
    sequence vc
    integer x,y,mode
    vc=video_config()
    mode=vc[VC_MODE]
    if length(params) >= 2 then
	x=params[1]
	y=params[2]
    else
	y=pop_stack()
	x=pop_stack()
    end if
    --if mode <= 3 or mode=7 then
	--x = floor(x/8)+1
	--y = floor(y/8)+1
    if mode=13 or mode=19 then
	x *= 2
    end if
    set_rat_xy(x,y)
end procedure
procedure mousePointer(sequence params)
    integer stat
    if length(params) then
	stat=params[1]
    else
	stat=pop_stack()
    end if
    if stat then
	show_rat()
    else
	hide_rat()
    end if
end procedure
procedure tRat(sequence params)
    rat()
end procedure
procedure tickRate(sequence params)
    integer rate
    if length(params) then
	rate=params[1]
    else
	rate=pop_stack()
    end if
    tick_rate(rate)
end procedure
procedure initRat(sequence params)
    init_rat()
end procedure
procedure mouseBtns(sequence params)
    push_stack(rat_button)
end procedure
procedure isAtom(sequence params)
    push_stack(atom(pop_stack()))
end procedure
procedure isInt(sequence params)
    push_stack(integer(pop_stack()))
end procedure
procedure isSequence(sequence params)
    push_stack(sequence(pop_stack()))
end procedure
procedure validFN(sequence params)
    integer fn
    if length(params) then
	fn=params[1]
    else
	fn=pop_stack()
    end if
    push_stack((fn >= 3))
end procedure
procedure squirt(sequence params)
    atom num
    if length(params) then
	num=params[1]
    else
	num=pop_stack()
    end if
    push_stack(sqrt(num))
end procedure
procedure squared(sequence params)
    atom num
    if length(params) then
	num=params[1]
    else
	num=pop_stack()
    end if
    push_stack(num*num)
end procedure
procedure g_a_p(sequence params)
    push_stack(get_all_palette())
end procedure
procedure a_p(sequence params)
    sequence pal
    pal=pop_stack()
    all_palette(pal)
end procedure
procedure setClr(sequence params)
    sequence rgb
    integer c
    if length(params) then
	c=params[1]
	rgb=params[2]
    else
	rgb=pop_stack()
	c=pop_stack()
    end if
    if atom(palette(c,rgb)) then
    end if
end procedure
procedure readbmp(sequence params)
    sequence fil
    object bm
    if length(params) then
	fil=params[1]
    else
	fil=pop_stack()
    end if
    bm=read_bitmap(fil)
    if sequence(bm) then
	push_stack(bm[2])
	push_stack(bm[1]/4.047619048)
    else
	push_stack(bm)
    end if
end procedure
procedure dispImage(sequence params)
    sequence xy
    if length(params) then
	xy=params[1]
    else
	xy=pop_stack()
    end if
    display_image(xy,pop_stack())
end procedure
procedure chSize(sequence params)
    sequence wh
    if length(params) then
	wh=params[1]
    else
	wh=pop_stack()
    end if
    push_stack(changeSize(pop_stack(),wh))
end procedure
procedure Prepend(sequence params)
    sequence lst
    object obj
    obj=pop_stack()
    lst=pop_stack()
    push_stack(prepend(lst,obj))
end procedure
procedure Append(sequence params)
    sequence lst
    object obj
    obj=pop_stack()
    lst=pop_stack()
    push_stack(append(lst,obj))
end procedure
procedure threadExists(sequence params)
    integer t
    if length(params) then
	t=params[1]
    else
	t=pop_stack()
    end if
    push_stack(thread_exists(t))
end procedure
procedure getPosition(sequence params)
    sequence pos
    pos=get_position()
    push_stack(pos[1])
    push_stack(pos[2])
end procedure
procedure linesCols(sequence params)
    sequence vc
    vc=video_config()
    push_stack(vc[4])
    push_stack(vc[3])
end procedure
procedure topazVal(sequence params)
    sequence s
    if length(params) then
	s=value(params[1])
	push_stack(s[2])
    else
	s=value(pop_stack())
	push_stack(s[2])
    end if
end procedure
procedure fileExists(sequence params)
    sequence fil
    if length(params) then
	fil=params[1]
    else
	fil=pop_stack()
    end if
    push_stack(sequence(dir(fil)))
end procedure
procedure findName(sequence params)
    sequence name,threadNames
    integer i
    if length(params) then
	name=params[1]
    else
	name=pop_stack()
    end if
    threadNames=getThreadNames()
    threadNames=upper(threadNames[1])
    name=upper(name)
    i=find(name,threadNames)
    if i=0 then
	push_stack(-1)
    else
	push_stack(getThreadID(i))
    end if
end procedure
procedure findNames(sequence params)
    sequence names,name
    integer i
    i=0
    names=getThreadNames()
    if length(params) then
	name=params[1]
    else
	name=pop_stack()
    end if
    for a = 1 to length(names) do
	if equal(names[a],name) then
	    i += 1
	end if
    end for
    push_stack(i)
end procedure
procedure setName(sequence params)
    sequence name
    integer id
    if length(params) >= 2 then
	id=params[1]
	name=params[2]
	setThreadName(id,name)
    else
	name=pop_stack()
	id=pop_stack()
	setThreadName(id,name)
    end if
end procedure
procedure getScanCode(sequence params)
    push_stack(Input(96))
end procedure
procedure and_it(sequence params)
    push_stack(and_bits(pop_stack(),pop_stack()))
end procedure
procedure or_it(sequence params)
    push_stack(or_bits(pop_stack(),pop_stack()))
end procedure
procedure xor_it(sequence params)
    push_stack(xor_bits(pop_stack(),pop_stack()))
end procedure
procedure not_it(sequence params)
    push_stack(not_bits(pop_stack()))
end procedure
procedure get_state(sequence params)
    push_stack(peek(#417))
end procedure
procedure slice_it(sequence params)
    sequence seq
    integer start,len
    if length(params) then
	seq=params[1]
	start=params[2]
	len=params[3]
    else
	seq=pop_stack()
	len=pop_stack()
	start=pop_stack()
    end if
    push_stack(seq[start..start+len])
end procedure
procedure topazLength(sequence params)
    push_stack(length(pop_stack()))
end procedure
procedure regMsg(sequence params)
    sequence name,names
    integer new
    names={}
    new=1
    if length(params) then
	name=params[1]
    else
	name=pop_stack()
    end if
    for a = 1 to length(msgs) do
	if equal(msgs[a][2],name) then
	    new=0
	    push_stack(a)
	    exit
	end if
    end for
    if new then
	msgs = append(msgs,{length(msgs),name,0})
	push_stack(length(msgs))
    end if
end procedure
procedure getMsgID(sequence params)
    sequence name
    integer i
    i=0
    if length(params) then
	name=params[1]
    else
	name=pop_stack()
    end if
    for a = 1 to length(msgs) do
	if equal(msgs[a][2],name) then
	    i=a exit
	end if
    end for
    push_stack(i)
end procedure
procedure topazGetFlags(sequence params)
    integer id
    if length(params) then
	id=params[1]
    else
	id=pop_stack()
    end if
    if id=#FFFF then
	push_stack(0) return
    end if
    push_stack(getFlags(id))
end procedure
procedure topazSetFlags(sequence params)
    integer id,flags
    if length(params) then
	id=params[1] flags=params[2]
    else
	flags=pop_stack()
	id=pop_stack()
	if flags=#FFFF or id=#FFFF then
	    return
	end if
    end if
    setFlags(id,flags)
end procedure
procedure topazNegate(sequence params)
    push_stack(-pop_stack())
end procedure
procedure callFunc(sequence params)
    sequence name,parms
    integer id
    name=params[1]
    parms=params[2]
end procedure
procedure getParam(sequence params)
    
end procedure
global constant tCOLOR  = add_instruction(routine_id("topaz_color")),
		tCOLORP = add_instruction(routine_id("topaz_color2")),
		tPUTST  = add_instruction(routine_id("topaz_putst")),
	      tFLOPPIES = add_instruction(routine_id("floppies")),
		tOPEN   = add_instruction(routine_id("topaz_open")),
		tCLOSE  = add_instruction(routine_id("topaz_close")),
		tPRINT  = add_instruction(routine_id("topaz_print")),
		tDOSVER = add_instruction(routine_id("topaz_dosver")),
		tLSH    = add_instruction(routine_id("topaz_lshift")),
		tROL    = add_instruction(routine_id("topaz_rol")),
		tROR    = add_instruction(routine_id("topaz_ror")),
		tUPUSH  = add_instruction(routine_id("uniPush")),
		tUPOP   = add_instruction(routine_id("uniPop")),
		tPRINTH = add_instruction(routine_id("printh")),
		tPRINTO = add_instruction(routine_id("printo")),
		tSOUND  = add_instruction(routine_id("snd")),
		tDELAY  = add_instruction(routine_id("Dly")),
		tEXEC   = add_instruction(routine_id("exec")),
		tABORT  = add_instruction(routine_id("abrt")),
		tGETKY  = add_instruction(routine_id("Getk")),
		tDECIP  = add_instruction(routine_id("decIP")),
		tNEWVAR = add_instruction(routine_id("newVar")),
		tGETVAR = add_instruction(routine_id("getVar")),
		tSETVAR = add_instruction(routine_id("setVar")),
	       --tFSETVAR = add_instruction(routine_id("fsetVar")),
	      tMOVSTACK = add_instruction(routine_id("var2Stack")),
	      tMOVVADDR = add_instruction(routine_id("var2Vaddr")),
	       tCMDLINE = add_instruction(routine_id("cmdline")),
	       tKILL    = add_instruction(routine_id("killthread")),
	       tDIE     = add_instruction(routine_id("die")),
	       tMODE    = add_instruction(routine_id("graphMode")),
	       tPOLYGON = add_instruction(routine_id("polYgon")),
	       tLINE    = add_instruction(routine_id("line")),
	       tPIXEL   = add_instruction(routine_id("pixl")),
	      tGETPIXEL = add_instruction(routine_id("getpixl")),
	       tELLIPSE = add_instruction(routine_id("ellips")),
	       tPUT32   = add_instruction(routine_id("put32")),
	       tPUT64   = add_instruction(routine_id("put64")),
	       tGET4    = add_instruction(routine_id("get4")),
	       tREVERSE = add_instruction(routine_id("revers")),
	       tPRINTF  = add_instruction(routine_id("Printf")),
	       tMONTH   = add_instruction(routine_id("month")),
	       tDAY     = add_instruction(routine_id("day")),
	       tYEAR    = add_instruction(routine_id("year")),
	       tHOUR    = add_instruction(routine_id("hour")),
	       tMINUTE  = add_instruction(routine_id("minute")),
	       tSECOND  = add_instruction(routine_id("second")),
	       tDOW     = add_instruction(routine_id("dow")),
	       tDOY     = add_instruction(routine_id("doy")),
	       tISCOLOR = add_instruction(routine_id("iscolor")),
	       tGMODE   = add_instruction(routine_id("mode")),
	    tDIMENSIONS = add_instruction(routine_id("dimensions")),
	       tCOLORS  = add_instruction(routine_id("colors")),
	       tPAGES  = add_instruction(routine_id("pages")),
	       tROWS   = add_instruction(routine_id("textrows")),
	     tPOSITION = add_instruction(routine_id("pos")),
	       tGETLN  = add_instruction(routine_id("getln")),
	       tGETCH  = add_instruction(routine_id("getch")),
	       tCHOP   = add_instruction(routine_id("chop")),
	       tCLS    = add_instruction(routine_id("cls")),
	      tADDPROG = add_instruction(routine_id("addProg")),
	       tJMP    = add_instruction(routine_id("jump")),
	      tTHREADS = add_instruction(routine_id("threads")),
	       tPOST   = add_instruction(routine_id("post")),
	       tGET    = add_instruction(routine_id("getMsg")),
	      tCLEAR   = add_instruction(routine_id("clearMsg")),
	      tLOOP    = add_instruction(routine_id("Loop")),
	      tAUTOMSG = add_instruction(routine_id("setAutoResponse")),
	      tRET = add_instruction(routine_id("popIP")),
	      tCALL = add_instruction(routine_id("callProc")),
	      tPEEK = add_instruction(routine_id("tPeek")),
	      tPOKE = add_instruction(routine_id("tPoke")),
	      tPEEK4U = add_instruction(routine_id("tPeek4u")),
	      tPEEK4S = add_instruction(routine_id("tPeek4s")),
	      tGET32 = add_instruction(routine_id("get32")),
	      tGET64 = add_instruction(routine_id("get64")),
	      tMOUSECOORDS = add_instruction(routine_id("mouseCoords")),
	      tSETCOORDS = add_instruction(routine_id("setCoords")),
	      tMOUSEPTR = add_instruction(routine_id("mousePointer")),
	      tRAT = add_instruction(routine_id("tRat")),
	      tTRATE = add_instruction(routine_id("tickRate")),
	      tINIT = add_instruction(routine_id("initRat")),
	      tMOUSEBTNS = add_instruction(routine_id("mouseBtns")),
	      tATOM = add_instruction(routine_id("isAtom")),
	      tINTEGER = add_instruction(routine_id("isInt")),
	      tSEQUENCE = add_instruction(routine_id("isSequence")),
	      tVALIDFN = add_instruction(routine_id("validFN")),
	      tSQRT = add_instruction(routine_id("squirt")),
	      tSQR = add_instruction(routine_id("squared")),
	      tGETPAL = add_instruction(routine_id("g_a_p")),
	      tSETPAL = add_instruction(routine_id("a_p")),
	      tSETCLR = add_instruction(routine_id("setClr")),
	      tREADBMP = add_instruction(routine_id("readbmp")),
	      tDISPLAY = add_instruction(routine_id("dispImage")),
	      tCHSIZE = add_instruction(routine_id("chSize")),
	      tPREPEND = add_instruction(routine_id("Prepend")),
	      tAPPEND = add_instruction(routine_id("Append")),
	      tEXISTS = add_instruction(routine_id("threadExists")),
	      tGETPOS = add_instruction(routine_id("getPosition")),
	      tLINESCOLS = add_instruction(routine_id("linesCols")),
	      tVALUE = add_instruction(routine_id("topazVal")),
	      tFEXISTS = add_instruction(routine_id("fileExists")),
	      tFINDNAME = add_instruction(routine_id("findName")),
	      tSETTHREADNAME = add_instruction(routine_id("setName")),
	      tGETSCODE = add_instruction(routine_id("getScanCode")),
	      tBAND = add_instruction(routine_id("and_it")),
	      tBOR = add_instruction(routine_id("or_it")),
	      tBXOR = add_instruction(routine_id("xor_it")),
	      tBNOT = add_instruction(routine_id("not_it")),
	      tGETSTATE = add_instruction(routine_id("get_state")),
	      tSLICE = add_instruction(routine_id("slice_it")),
	      tLEN=add_instruction(routine_id("topazLength")),
	      tFINDNAMES=add_instruction(routine_id("findNames")),
	      tREGMSG=add_instruction(routine_id("regMsg")),
	      tGETMSGID=add_instruction(routine_id("getMsgID")),
	      tGETFLAGS=add_instruction(routine_id("topazGetFlags")),
	      tSETFLAGS=add_instruction(routine_id("topazSetFlags")),
	      tNEGATE=add_instruction(routine_id("topazNegate")),
	      tGETPARAM=add_instruction(routine_id("getParam")),
	      tRETURN=add_instruction(routine_id("retrn")),
	      tFUNCTION=add_instruction(routine_id("callFunc"))
procedure pushIt(sequence params)
    integer k,targetThread,keyID,SuspendedID
    keyID=pop_stack()
    SuspendedID=sIDs[find(keyID,keyIDs)]
    k=get_vaddress(1)
    targetThread=find(SuspendedID,ThreadIDTable)
    if targetThread=0 then
	return
    end if

    StackTable[targetThread] &= k
    StackSizeTable[targetThread] = StackSizeTable[targetThread] + 1
    resume(SuspendedID)
    keyIDs = removeIndex(keyIDs,find(keyID,keyIDs))
    sIDs = removeIndex(sIDs,find(SuspendedID,sIDs))
end procedure
constant tPUSHIT = add_instruction(routine_id("pushIt"))
procedure getk(sequence params)
    sequence code
    integer id,ID
    ID=get_thread_id()
    sIDs &= {ID}
    suspend(ID)
    code={
	  {tINCIP,2},
	  {tPOP,0},
	  {tGETKY},
	  {tCOPY},
	  {tPUSHD,-1},
	  {tEQ},
	  {tIF,{tJMP,2}},
	  {tPOP,1},
	  {tPUSHA,1},
	  {tGETID},
	  {tPUSHIT,ID},
	  {tEND}
	}
    id=new_thread(1,0,code)
    keyIDs &= id
    setFlags(id,FLAGS_KILL1)
    setThreadName(id,sprintf("key%d",length(keyIDs)))
end procedure
global constant tGETKEY = add_instruction(routine_id("getk"))

include std_EAD.e
--? (tSETFLAGS-tCOLOR)+1
